#ifndef COURSE_HPP
#define COURSE_HPP

#include <vector>
#include <string>
#include "universitystudent.hpp"
#include "universityteacher.hpp"

class Course // kurzus osztlya
{
public:
    Course(const std::string& n, UniversityTeacher* t, int credits = 0, unsigned int maxHeadCount = 0);

    bool newStudent(const UniversityStudent* s); // j hallgat felvtele a kurzushoz

    std::string name() const { return _courseName; }
    const UniversityTeacher* teacher() const { return _teacher; }
    int credits() const { return _credits; }
    int maxHeadCount() const { return _maxHeadCount; }
    int currentHeadCount() const { return _students.size(); }

private:
    std::string _courseName;
    UniversityTeacher* _teacher;
    int _credits;
    unsigned int _maxHeadCount;
    std::vector<const UniversityStudent*> _students; // a hallgatok mutatkat trol
};

#endif // COURSE_HPP
