#ifndef UNIVERSITYCITIZEN_HPP
#define UNIVERSITYCITIZEN_HPP

#include <vector>
#include <string>

class Course;

class UniversityCitizen
{
public:
    virtual ~UniversityCitizen() {} // virtulis destruktor

    std::string name() const;
    std::string neptunCode() const;
    const std::vector<Course*>& courses() const;
    int numberOfCourses() const;

    virtual void newCourse(Course* c) = 0; // absztrakt metdus

protected: // rejtett s a leszrmazottban lthat tulajdonsgok
    std::string _name;
    std::string _neptunCode;
    std::string _neptunPassword;
    std::vector<Course*> _courses;

    UniversityCitizen(const std::string& n); // a konstrukort elrejtjk, hogy ne lehessen pldnyostani

private: // rejtett s a leszrmazottban nem lthat tulajdonsgok
    std::string generateCode();
    std::string generatePassword();
};

#endif // UNIVERSITYCITIZEN_HPP
